function [uu0,iiut,index] = newscore(betahat,betaIndex,data) %betahat gives estimates (set to []in the first trial) of the variables already included in the model. 
%betaIndex gives the index(column number) of these genes(set to [] in the first trial). 
X = data(:,3:size(data,2)); %nxp matrix 
eventTime = data(:,1); 
censIndex = data(:,2);

index = setdiff(1:size(X,2),betaIndex);
deathIndex=censIndex==1;
beta = repmat(0,size(X,2),1); %vector of beta values BETA SKAL VRE NULL FOR ALLE BORTSETT FRA DE VI SENDER INN
beta([betaIndex]) = betahat;
eXp = exp(X*beta); % exponent

matrixExp = repmat(eXp,1,size(X,2)); %nxp matrix concisting of p eXp columns.
uu = X .* matrixExp; % nxp matrix 

cumUU = cumsum(uu,1); %cumsum on the columns of uu

cumEXP = cumsum(eXp,1); %cumsum on eXp
matrixcumExp = repmat(cumEXP,1,size(X,2));

frac = cumUU ./ matrixcumExp;

deathIndex2 = repmat(deathIndex,1,size(X,2));
product = deathIndex2.*X;
test1 = sum(product,1);

fracReal = deathIndex2.*frac;
test= sum(fracReal,1);

uu0 = test1-test;
uu0 = uu0(index); %the score 

%INFORMATION

ut=[]; %used as start value in first 'run'
jj=1; %used as start value in first 'run'
kk=1; %used as start value in first 'run'
iiut=[]; %used as start value in first 'run'

ll=length(betaIndex);

%IMPORTANT OBSERVATION:
%when computing the (p+1)x(p+1) information matrix for all the genes(where p is the number of genes already 
%picked out by the model), we only have to compute the pxp submatrix once.
%This is done by the two for-loops below. The last part is computed by the
%bottom two for-loops. 

for j = 1:ll
    jj=jj+1;
    pp=betaIndex(j);
    xxx=X(:,pp);
    ff=fracReal(:,pp);
    for k = j:ll
        kk=kk+1;
        ppp=betaIndex(k);
        xxxx=X(:,ppp);
        fff=fracReal(:,ppp);
        del1 = xxx.*xxxx.*eXp;
        cumDel1 = cumsum(del1,1);
        del2 = cumDel1./cumEXP;
        del2d = deathIndex.*del2;
        ut1 = sum(del2d,1);
        del3 = ff.*fff;
        ut2 = sum(del3,1);
        ut(jj,kk) = ut1-ut2;
        ut(kk,jj) = ut(jj,kk);
    end
    kk=jj;
end


ll=ll+1; %length(betaIndex)+new variable

for i = index
    bb=[i,betaIndex];
    xxx=X(:,i);
    fff=fracReal(:,i);
    for k = 1:ll
        tt=bb(k);
        xxxx=X(:,tt);
        ffff=fracReal(:,tt);
        del1 = xxx.*xxxx.*eXp;
        cumDel1 = cumsum(del1,1);
        del2 = cumDel1./cumEXP;
        del2d = deathIndex.*del2;
        ut1 = sum(del2d,1);
        del3 = fff.*ffff;
        ut2 = sum(del3,1);
        ut(1,k) = ut1-ut2;
        ut(k,1) = ut(1,k);
    end
    oo = inv(ut);
    iiut = [iiut,oo(1)];
end

