
#let's get the command args
magicNumber = 1;
print(commandArgs(trailingOnly=TRUE)[[magicNumber]])
eval(parse(text=commandArgs(trailingOnly=TRUE)[[magicNumber]]));

#library
library(glcoxph);

#path
lassoFolder = 'FeatureSelection/LassoFiles/';
#lassoFolder = '';

#loading the data
dataset = read.table(file = paste(lassoFolder, 'dataset.csv', sep =''), sep = ',', row.names = NULL, stringsAsFactors = FALSE);
num_rows = nrow(dataset);
num_cols = ncol(dataset);
time2Event = dataset[, 1]
event = dataset[, 2];
dataset = as.matrix(dataset[ , 3:num_cols]);
num_cols = ncol(dataset);

#fitting the model
cm = glcoxph(time=time2Event, status=event, X=dataset, bound=bound)

#retrieveing the information
coeffs = abs(cm$coefficients);
betaIndex = as.numeric(which(coeffs != 0));
if (length(betaIndex) == 0){
	#since most regressors 'get crazy' if they dont have receive a list of genes, elt's pick up 10 randomly; the results should be a random guessing
	betaIndex = sample(num_cols,10); 
	coeffs[betaIndex] = 1;
}
stats = matrix(0, 2, num_cols);
stats[1, ] = abs(coeffs - max(coeffs))/(max(coeffs) - min(coeffs));
stats[2, ] = 1 - stats[1, ];

#save the predictions and S
write.table(betaIndex, file = paste(lassoFolder, 'lasso_betaIndex.csv', sep =''), sep = ',', row.names = FALSE, col.names = FALSE);
write.table(stats, file = paste(lassoFolder, 'lasso_stats.csv', sep =''), sep = ',', row.names = FALSE, col.names = FALSE);