function lamb=genlam(nu,d,W,X,r,alpha0,h0,beta0,Hg,lamb,v0,v2)

%genlam: Sampling of lamdba
%        For log-t case
%
%NOTE: input d=1.57 and nu=8 for log-logit;
%
%Copyright (c) 2006 Naijun Sha.
%**********************************************************************

n=length(W);
Hgr=Hg(r,r);
Xr=X(:,r);
beta0r=beta0(r);

for i=1:n
%----compute log likelihood with old lambda------  
    L=diag(lamb);
    Pr=d^2*L+h0*ones(n,n)+Xr*Hgr*Xr';
    R=chol(Pr);
    Rinv=inv(R);
    PrINV=Rinv*Rinv';
    loglike=-1/2*log(det(Pr))+v0/2*log(v2)-...
            (n+v0)/2*log(v2+(W-alpha0*ones(n,1)-Xr*beta0r)'*PrINV*(W-alpha0*ones(n,1)-Xr*beta0r));

%----compute log likelihood with new lambda------
    
    lambnew=lamb;
    lambo=lamb(i);
    lambn=1/gamrnd(nu/2,2/(nu*lambo));
    lambnew(i)=lambn;
    Lnew=diag(lambnew);
    Prnew=d^2*Lnew+h0*ones(n,n)+Xr*Hgr*Xr';
    Rnew=chol(Prnew);
    Rnewinv=inv(Rnew);
    PrnewINV=Rnewinv*Rnewinv';
    loglikenew=-1/2*log(det(Prnew))+v0/2*log(v2)-...
            (n+v0)/2*log(v2+(W-alpha0*ones(n,1)-Xr*beta0r)'*PrnewINV*(W-alpha0*ones(n,1)-Xr*beta0r));

    logratio=loglikenew-loglike+nu/2*(log(lambn)-log(lambo))-nu/2*...
             (lambn/lambo-lambo/lambn+1/lambn-1/lambo);
    ratio=exp(logratio);u=rand(1);
    if u<=ratio
       lamb(i)=lambn;
    end
end
