function [r,prop,move]=updr(r,p)

%updr: Bayesian Variable Selection for AFT models
%       Update variable selection index r via randomly chosen move.
%
%NOTES:
% An adding move is forced with empty model
% A delete move is forced with full model

%Copyright (c) 2006 Naijun Sha and Marina Vannucci.
%**********************************************************************
   
a=1:p;
b=zeros(1,p);
b(r)=1;
r=b;

if length(find(r==0))==p
	loc=unidrnd(p);prop=1;
      	r(loc)=1-r(loc);
      	move = 1;
elseif length(find(r==1))==p
   	loc=unidrnd(p);prop=1;
      	r(loc)=1-r(loc);
      	move = 1;
else 
	move=unidrnd(2); % CHANGE '2' TO '3' IF YOU WANT TO ALLOW SWAPS WITH NEIGHBOURS
	switch move
	 %Add or Delete step: randomly choose a variable index 
	 %and then change it from 0 to 1 or 1 to 0
	case 1
                if length(find(~r))==p-1
	           zeroloc=find(~r);loc=zeroloc(unidrnd(p-1));
                   r(loc)=1;prop=(p-1)/p;
                else
		   loc=unidrnd(p);prop=1;
      		   r(loc)=1-r(loc);
                end

	 %Swap step: exchange 0-1 variable randomly chosen among the used and unused
	case 2
   		zeronum=a(r==0);onenum=a(r==1);
   		len0=length(zeronum);len1=length(onenum);
   		b0=unidrnd(len0);b1=unidrnd(len1);
   		loc0=zeronum(b0);loc1=onenum(b1);
   		r(loc0)=1;r(loc1)=0;
   		prop=1;

	 %swap it with its left or right neighbour
	case 3
		test=0;
		while test==0
  	 	  loc=unidrnd(p);
   		  if loc==1 & r(1)~=r(2)
      			rval1=r(1);r(1)=r(2);r(2)=rval1;
      			prop=0.5;
			test=1;
   		  elseif loc==p & r(p-1)~=r(p)
      			rvalp=r(p);r(p)=r(p-1);r(p-1)=rvalp;
      			prop=0.5;
			test=1;
   		  elseif loc > 1 & loc < p 
      			u=rand(1);
      			if u<.5 
         		  if r(loc-1)~=r(loc) % swap it with its left.
            		    rval=r(loc);	
			    r(loc)=r(loc-1);
			    r(loc-1)=rval;
  			    prop=1;
			    test=1;
         		  end;
      			else
         		  if r(loc+1)~=r(loc) % swap it with its right.
            		    rval=r(loc);
			    r(loc)=r(loc+1);
			    r(loc+1)=rval;
            		    prop=1;
			    test=1;
			  end;
      		        end;
   		  end;
	      end;
	end	
end
r=find(r);







