function [betaIndex statistics, MargGam, UniD, GammaD, Gamma,PostGam,What,lhat,alpha0,beta0,h0,Hg,s20,d]= MCMCSelection(data,time,censored,parameter)

%updating the path
path(path, 'FeatureSelection/MCMCFiles/');
path(path, 'MCMCFiles/');

%formatting the data according to the original code
binary = (sum(data == 1) + sum(data == 0) == size(data,1))';
Xtrain = data;
meanx=mean(Xtrain(:,~binary));
Xtrain(:,~binary)=scale(Xtrain(:,~binary),meanx); %subtract the mean
traindata(:,1) =time;
traindata(:,2) = ~censored;

%fixed parameter. Default values are derived from the article
[n,p] = size(Xtrain);
alpha0 = 0;
beta0 = zeros(p,1);
h0 = 1e6;
h = 1;               
Hg=h*speye(p);
s20= 1;
iter = 200000;
burnin = 100000;
type=1; %type=1;lognormal data %type=2;log-t
d = 1; %useful only with type = 2;

%parameter to be set; initial number of variables
initial = parameter.initial;
w = initial/p; % Binomial prior with expected model size 'initial'

%let's do the MCMM stuff! (it will never finish... ;-)
[Uni,UniD,Gamma,GammaD,logProb,logProbD,PostGamD,MargGam,Wmat,Lmat,accprob]=bvsme_aft(...
    type,Xtrain,traindata,alpha0,beta0,h0,Hg,s20,w,initial,iter,burnin);
Wmat=Wmat(burnin+1:end,:);

if type==2
Lmat = Lmat(burnin+1:end,:);
else
    Lmat=[];
end
What=(mean(Wmat))'; 
lhat=mean(Lmat);

[MargGam,UniD,GammaD]=postinfer(...
    type,Xtrain,traindata,UniD,GammaD,What,lhat,alpha0,beta0,h0,Hg,s20,w,d);

%let's get the result!
betaIndex = str2num(GammaD{1}); %#ok<ST2NM>
statistics = -1 * ones(2,length(MargGam));
statistics(1,:) = 1 - MargGam;
statistics(2,:) = MargGam;


function scaledData = scale(dataToScale, means)

scaledData = zeros(size(dataToScale));
for i = 1:size(dataToScale,2)
    scaledData(:,i) = dataToScale(:,i)-means(i);
end
