function [betaIndex statistics] = forwardSelection(data,time,censored,parameter)

%updating the path
path(path, 'FeatureSelection/ForwUniFiles/');
path(path, 'ForwUniFiles/');

%modifying the data according to the original code
data = [time, ~censored, data];

%new order
data = flipud(sortrows(data,1));

max_k = floor(parameter.ratio * size(data,1));
if max_k == 0
    max_k = 1;
end

betahat = [];
betaIndex = [];
%statistics(1,:) = p values
%statistics(2,:) = chi squared stats
statistics = size(data,2)*ones(2, size(data,2)-2); 

for kk = 1:size(data,2)
    
    %disp(['Forward Selection: selecting the ' num2str(kk) ' variable']);
    [score,inform,orderGene] = newscore(betahat,betaIndex,data);
    kji = score.^2.*inform;
    nn = ones(1,length(kji));%Vektor with degrees of freedom
    pValue = [1-chi2cdf(kji,nn);orderGene; kji]'; %putting  togheter to keep track of the genes.
    res = sortrows(pValue,1); %gives us the genes in ascending order according to the p-value
    %disp(['Var: ' num2str(res(1,2)) ' p-value: ' num2str(res(1,1))]);
    %termination criteria
    
    betaIndex = [betaIndex,res(1,2)]; %new betaIndex
    statistics(1,res(:,2)) = res(:,1);
    statistics(2,res(:,2)) = res(:,3);

    if length(betaIndex) >= max_k  
    
		%let's modify the statistics
		statistics(1, isnan(statistics(1,:))) = 1;
		statistics(2, isnan(statistics(2,:))) = 0;
		
		return
		
    end
    
    %all the variables have been selected? Let's get out!
    if length(betaIndex) == (size(data,2)-2)% '-2' because there are also time and event

   		%let's modify the statistics
		statistics(1, isnan(statistics(1,:))) = 1;
		statistics(2, isnan(statistics(2,:))) = 0;

        return
    end

    try
        i =0; %initialverdi for fminunc (valgt tilfeldig)
        x0=[betahat;i];%gir en tilfeldig initialverdi.
        options = optimset('Display','off','GradObj','on','MaxFunEvals',100000,'TolX',1e-15,'TolFun',1e-15,'MaxIter',1000);
        [betahat,FVAL,EXITFLAG] = fminunc('retFunAndGrad',x0,options,betaIndex,data,0);%estimates the beta. partlik is a function
% EXITFLAG
% OUTPUT
        if EXITFLAG<1
            disp(['Problemer ', num2str(EXITFLAG),' \n'])        
			%let's modify the statistics
			statistics(1, isnan(statistics(1,:))) = 1;
			statistics(2, isnan(statistics(2,:))) = 0;
            return
        end
    catch
        fprintf(['Error message from MATLAB: \n',lasterr]);
        fprintf('Problemer med aa estimere beta\n')
		%let's modify the statistics
		statistics(1, isnan(statistics(1,:))) = 1;
		statistics(2, isnan(statistics(2,:))) = 0;
        return %bryter ut av funksjonen
    end
end
