function [betaIndex statistics] = lassoSelection(data,time,censored,parameter)

%updating path
if isunix
    lassoFolder = 'FeatureSelection/LassoFiles/';
else
    lassoFolder = 'FeatureSelection\LassoFiles\';
end
addpath(lassoFolder);

%getting the option
option = parameter.bound;

%let's unify the data
dataset = [time ~censored data];

%let's write the data on a file
csvwrite([lassoFolder 'dataset.csv'], dataset)

%let's call the R function
if isunix
    [result logTrace] = system(['/home/vlagani/R-installation/bin/R CMD BATCH --no-save --no-restore ''--args bound=' num2str(option) ';'' ' lassoFolder 'lasso_script.R ' lassoFolder 'lasso.out']);
end
if ispc
    [result logTrace] = system(['"C:\Programmi\R\R-2.12.0\bin\i386\Rcmd" BATCH --no-save --no-restore "--args bound=' num2str(option) '" ' lassoFolder 'lasso_script.R ' lassoFolder 'lasso.out']);
end

if result ~= 0
    save lasso_log logTrace -ASCII;
    error('FEATURESELECTION:LASSO', 'Something wrong in lasso_script.r')
end

%reading the results
betaIndex = csvread([lassoFolder 'lasso_betaIndex.csv']);
statistics = csvread([lassoFolder 'lasso_stats.csv']);