function [betaIndex statistics] = univariateSelection(data,time,censored,parameter)

%updating the path
path(path, 'FeatureSelection/ForwUniFiles/');
path(path, 'ForwUniFiles/');

%modifying the data according to their format
data = [time, ~censored, data];
threshold = parameter.threshold;

%new order
data = flipud(sortrows(data,1));

betahat = [];
betaIndex = [];

[score,inform,orderGene] = newscore(betahat,betaIndex,data);
kji = score.^2.*inform;
nn = ones(1,length(kji));%Vektor with degrees of freedom
pValue = [1-chi2cdf(kji,nn);orderGene;kji]'; %putting these three togheter to keep track of the genes and statistics
res = sortrows(pValue,1); %gives us the genes in ascending order according to the p-value

number = find(res(:,1)>threshold,1);

%correction: if number is empty, all the attributes must be collected
if isempty(number)
    betaIndex = res(:,2)';
else
    betaIndex = res(1:(number-1),2)';
end

%re ordering the genes and returning the statistics
res = sortrows(pValue,2);
statistics = -1*ones(2,length(res));
statistics(1,:) = res(:,1);
statistics(2,:) = res(:,3);