function [model prediction]= AFT(trData,trTime,trCensored,teData,teTime,teCensored,parameter)

numCases = sum(trCensored == 0);
numVars = size(trData,2);

if numVars < 2*numCases

	path('Regression/AFT',path);
	%path('AFT',path);

	%getting the option
	option = parameter.dist;

	%let's unify the data
	idx = [ones(size(trData,1),1); zeros(size(teData,1),1)];
	dataset = [[trData trTime ~trCensored];[teData teTime ~teCensored]];
	dataset = [dataset idx];

	%let's write the data on a file
	csvwrite('Regression/AFT/dataset.csv', dataset)

	%let's call the R function
	if isunix
		[result logTrace] = system(['/home/vlagani/R-installation/bin/R CMD BATCH --no-save --no-restore ''--args psmdistr="' option '"'' Regression/AFT/aft.R Regression/AFT/aft.out']);
	end
	if ispc
		[result logTrace] = system(['"C:\Program Files\R\R-2.9.2\bin\Rcmd" BATCH --no-save --no-restore "--args psmdistr=''' option '''" Regression\AFT\aft.R Regression\AFT\aft.out']);
	end

	if result ~= 0
	    save aft_log logTrace -ASCII;
	    error('REGRESSION:AFT', 'Something wrong in aft.r')
	end


	%prediction
	prediction = csvread('Regression/AFT/aft_predictions.csv');
    model.S = csvread('Regression/AFT/aft_S.csv');

else

	prediction = zeros(length(teTime),1);
    model.S = zeros(length(teTime),length(trTime(trCensored == 0)));

end

%let's build the model!
model.type = 'AFT';
model.timeOfInterest = sort(trTime(trCensored == 0));
