function [model prediction]= RSF(trData,trTime,trCensored,teData,teTime,teCensored,parameter)

%first check... RSF predict does not work with only one variable
num_vars = size(trData,2);
if num_vars == 1
    
    disp('RSF correction needed');
    prediction = zeros(length(teTime), 1);
    model.timeOfInterest = trTime(trCensored == 0);
    model.S = zeros(length(teTime), length(model.timeOfInterest));
    model.type = 'RSF';
    
else
    
    path('Regression/RSF',path);
    %path('RSF',path);

    %getting the option
    option = parameter.nsplit;

    %let's unify the data
    idx = [ones(size(trData,1),1); zeros(size(teData,1),1)];
    dataset = [[trData trTime ~trCensored];[teData teTime ~teCensored]];
    dataset = [dataset idx];

    %let's write the data on a file
    csvwrite('Regression/RSF/dataset.csv', dataset)

    %let's call the R function
    if isunix
        [result logTrace] = system(['/home/vlagani/R-installation/bin/R CMD BATCH --no-save --no-restore ''--args nsplit=' num2str(option) ''' Regression/RSF/rsf_script.R Regression/RSF/rsf.out']);
    end
    if ispc
        [result logTrace] = system(['"C:\Program Files\R\R-2.9.2\bin\Rcmd" BATCH --no-save --no-restore "--args nsplit=' num2str(option) '" Regression\RSF\rsf_script.R Regression\RSF\rsf.out']);
    end

    if result ~= 0
        save rsf_log logTrace -ASCII;
        error('REGRESSION:RSF', 'Something wrong in rsf.r')
    end

    %prediction
    prediction = csvread('Regression/RSF/rsf_predictions.csv');
    model.S = csvread('Regression/RSF/rsf_S.csv');

    %let's build the model!
    model.type = 'RSF';
    model.timeOfInterest = csvread('Regression/RSF/rsf_timeOfInterest.csv');

end