function [model prediction]= coxRegression(trData,trTime,trCensored,teData,teTime,teCensored,parameter)

numCases = sum(trCensored == 0);
numVars = size(trData,2);

if numVars < 2*numCases

    [b Logl H] = coxphfit(trData, trTime, 'censoring', trCensored);

    %creation of prediction
    prediction = teData*b;

    %creation of the model
    model.type = 'coxRegression';
    model.b = b;
    model.H = H;
    
    %creation of S and time of interest
    H0 = H(2:end, 2); % deleting the 'fake' first row
    model.timeOfInterest = H(2:end, 1);
    model.S = exp(-1 * H0 * exp(prediction)')';

else
    
    %creation of the model
    model.type = 'coxRegression';
    model.b = zeros(numVars,1);
    model.H = [[min(trTime(trCensored == 0)); sort(trTime(trCensored == 0))] zeros(sum(trCensored == 0)+1,1)];
    model.S = zeros(length(teTime), sum(trCensored == 0));
    model.timeOfInterest = sort(trTime(trCensored == 0));
    
    %creation of prediction
    prediction = teData*model.b;
    
end
