function [model prediction]= ridgeRegression(trData,trTime,trCensored,teData,teTime,teCensored,parameter)

path('Regression/Ridge',path);
%path('Ridge',path);

lambda = parameter.lambda;

[b LogL H] = coxphfit2(trData, trTime, 'censoring', trCensored, 'lambda', lambda);

%creation of prediction
prediction = teData*b;

%creation of the model
model.type = 'ridgeRegression';
model.b = b;
model.H = H;

%creation of S and time of interest
H0 = H(2:end, 2); % deleting the 'fake' first row
model.timeOfInterest = H(2:end, 1);
model.S = exp(-1 * H0 * exp(prediction)')';
