function index = CI(model, prediction, data, actualTime, censored)

%this function compare the c - index for a set of censored predictions

%let's find the type of the model

direct = {'SVCR', 'AFT', 'RSF'};
inverse = {'coxRegression', 'ridgeRegression'}; 

comparable = 0;
swapped = 0;
modelType = model.type;

%adjusting for model type
if sum(strcmp(modelType, direct)) == 1
	prediction = -prediction;
end

%let's compute the index
for i = 1:(length(prediction)-1)
    for j = (i+1):length(prediction)

        firstTime = actualTime(i);
        secondTime = actualTime(j);
        firstPrediction = prediction(i);
        secondPrediction = prediction(j);
        firstCensored = censored(i);
        secondCensored = censored(j);

        if ~((firstTime <= secondTime && firstCensored == 1)||(secondTime <= firstTime && secondCensored == 1))

            comparable = comparable+1;
            
            if (firstTime < secondTime && firstPrediction <= secondPrediction)...
                || (secondTime < firstTime && secondPrediction <= firstPrediction)...
                || (secondTime == firstTime && secondPrediction ~= firstPrediction)

                swapped = swapped+1;
                
            end

        end

    end
end 

index = (comparable - swapped)/comparable;
