function [pvalue stat, distr] = findAndCompare(dataset, FS, RE, metric, FS_base, RE_base, direction, numPermutations)

%hard coded parameters
datasetsFold = 'dataset/';
regressionResultsFold = 'regressionResults/';
synthesisFold = 'synthesis/';

%let's load the dataset
load([datasetsFold dataset]);
num_folds = max(ext_indices);

%loading the results of the regression (base)
load([regressionResultsFold dataset '_'  FS_base '_' RE_base]);

%loading the results of the synthesis (base)
load([synthesisFold dataset '_' FS_base '_' RE_base '_synthesis']);

%let's recall the data
predsAs = cell(num_folds,1);
modelAs = cell(num_folds,1);
for i =1:num_folds
   predsAs{i,1} = ext_predictions{i, best_FS_parameter(i), best_RE_parameter(i)};  %#ok<USENS>
   modelAs{i,1} = ext_models{i, best_FS_parameter(i), best_RE_parameter(i)};  %#ok<USENS>
end

%loading the results of the regression
load([regressionResultsFold dataset '_' FS '_' RE]);

%loading the results of the synthesis
load([synthesisFold dataset '_' FS '_' RE '_synthesis']);

%let's recall the data
predsBs = cell(num_folds,1);
modelBs = cell(num_folds,1);
for i =1:num_folds
   predsBs{i,1} = ext_predictions{i, best_FS_parameter(i), best_RE_parameter(i)};  %#ok<USENS>
   modelBs{i,1} = ext_models{i, best_FS_parameter(i), best_RE_parameter(i)};  %#ok<USENS>
end

%let's do the computations!
stats = nan(num_folds, 1);
distrs = nan(num_folds, numPermutations);

for i = 1:num_folds
    [pvalue valueA valueB permValuesA permValuesB] = permutationTest(metric, direction, numPermutations, predsAs{i}, modelAs{i}, predsBs{i}, modelBs{i}, time(ext_indices == i), censored(ext_indices == i));
    stats(i,1) = valueA - valueB;
    distrs(i,:) = permValuesA - permValuesB;
end

[pvalue stat distr] = meanEmpiricalTest(stats, distrs, direction);