function [] = resultsSynthesis(datasets, FSs, REs, ext_metric, FS_base, RE_base, test_direction, numPermutations)


%hard coded settings
addpath(path, 'metrics/');
addpath(path, 'permutationTest/');
regressionResultsFold = 'regressionResults/';
synthesisFold = 'synthesis/';
outputFile = 'resultsSynthesis';

%num of external metrics
num_ext_metric = length(ext_metric);

% variable to be saved
perm_test_comparisons = nan*ones(length(FSs), length(datasets), length(REs), length(ext_metric));
ext_metric_means = nan*ones(length(FSs), length(datasets),  length(REs), length(ext_metric));

%loop over the regression algorithm
for r = 1:length(REs)
    
    %selecting RE
    RE = REs{r};

    for d = 1:length(datasets)

        dataset = datasets{d}; 

        %feature selection algorithms
        for f = 1:length(FSs)

            FS = FSs{f};

            %loading the results file
            try
                disp(['Synthesis; Processing file: ' dataset '_' FS '_' RE]);
                load([regressionResultsFold dataset '_' FS '_' RE]);
                load([synthesisFold dataset '_' FS '_' RE '_synthesis']);
            catch %#ok<CTCH>
                disp(['File: ' dataset '_' FS '_' RE ' not available']);
                continue;
            end
            
            %comparisons
            for m = 1:num_ext_metric
                metric = ext_metric{m};
                
                if strcmp(RE, 'SVCR') && strcmp(metric, 'IBS')
                    ext_metric_means(f,d,r,m) = NaN;
                    perm_test_comparisons(f,d,r,m) = NaN;
                else
                    ext_metric_means(f,d,r,m) = mean(ext_evaluations(:,m));
                    perm_test_comparisons(f,d,r,m) = findAndCompare(dataset, FS, RE, metric, FS_base, RE_base, test_direction, numPermutations);
                end
                
            end
			
            %save once for each FS algorithm
            save(outputFile, 'FSs', 'datasets', 'REs', 'ext_metric', 'ext_metric_means', 'perm_test_comparisons');

        end

    end

end

save(outputFile, 'FSs', 'datasets', 'REs', 'ext_metric', 'ext_metric_means', 'perm_test_comparisons');


